/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package p4uclient;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;

/**
 * アプリの設定を管理
 * @author tondol
 */
public class OptionManager {
    String host     = "localhost";
    String downdir  = "./down/";
    String updir    = "./up/";
    String filename = null;
    int port   = 8888;
    int listen = (int)(Math.random() * 65536);
    
    /**
     * オプションを読み込む
     */
    public OptionManager(String filename) {
        this.filename = filename;
        FileReader     ifstream = null;
        BufferedReader reader   = null;
        try {
            ifstream = new FileReader(filename);
            reader   = new BufferedReader(ifstream);
            host    = reader.readLine();
            port    = Integer.parseInt(reader.readLine());
            listen  = Integer.parseInt(reader.readLine());
            updir   = reader.readLine();
            downdir = reader.readLine();
            MainApp.window.putMessage("o 設定読込");
        } catch (Exception e) {
            MainApp.window.putMessage("x 設定読込");
        } finally {
            try {
                if (reader   != null) reader.close();
                if (ifstream != null) ifstream.close();
            } catch(Exception e) {
            }
        }
    }
    
    /**
     * オプションを書き込む
     */
    public void close() {
        FileWriter  ofstream = null;
        PrintWriter writer   = null;
        try {
            ofstream = new FileWriter(filename);
            writer   = new PrintWriter(ofstream);
            writer.println(host);
            writer.println(port);
            writer.println(listen);
            writer.println(updir);
            writer.println(downdir);
            writer.flush();
            MainApp.window.putMessage("o 設定書込");
        } catch (Exception e) {
            MainApp.window.putMessage("x 設定書込");
        } finally {
            try {
                if (writer   != null) writer.close();
                if (ofstream != null) ofstream.close();
            } catch(Exception e) {
            }
        }
    }
}
